@use './styles/form-checkbox.variations' as variations;
@use './styles/form-checkbox.variables' as *;
@use './styles/form-checkbox-check.mixin' as *;
@use './../../../global/styles/utilities' as *;

:host {
  @include digi-form-checkbox--variables;
  $base: '.digi-form-checkbox';

  .digi-form-checkbox {
    --BACKGROUND--DEFAULT: var(--digi--form-checkbox--background-color);
    --BORDER-COLOR--DEFAULT: var(--digi--form-checkbox--border-color);

    position: relative;

    &--primary {
      @include variations.primary;
    }
    &--secondary {
      @include variations.secondary;
    }
    &--error {
      .digi-form-checkbox__input:not(:checked)
        ~ .digi-form-checkbox__label
        .digi-form-checkbox__box {
        @include variations.error;
        box-shadow: inset 0 0 0 var(--digi--border-width--primary)
          var(--digi--form-checkbox--box-shadow--error);
      }
      .digi-form-checkbox__input
        ~ .digi-form-checkbox__label
        .digi-form-checkbox__box {
        background-color: var(--BACKGROUND--CHECKED);
        border-color: var(--BORDER-COLOR--CHECKED);
      }
    }
    &--warning {
      .digi-form-checkbox__input:not(:checked)
        ~ .digi-form-checkbox__label
        .digi-form-checkbox__box {
        @include variations.warning;
        box-shadow: inset 0 0 0 var(--digi--border-width--primary)
          var(--BORDER-COLOR--CHECKED);
      }
      .digi-form-checkbox__input
        ~ .digi-form-checkbox__label
        .digi-form-checkbox__box {
        background-color: var(--BACKGROUND--CHECKED);
        border-color: var(--BORDER-COLOR--CHECKED);
      }
    }

    &--indeterminate {
      .digi-form-checkbox__input
        ~ .digi-form-checkbox__label
        .digi-form-checkbox__box {
        &::after {
          @include form__checkbox-check($indeterminate: true);
        }
      }
    }
  }
}

.digi-form-checkbox__input {
  position: absolute;
  opacity: 0;
  cursor: pointer;
  height: 0;
  width: 0;
  top: 0;
  left: 0;
}

.digi-form-checkbox__label {
  display: inline-flex;
  align-items: center;
  gap: var(--digi--gutter--icon);
  font-family: var(--digi--global--typography--font-family--default);
  font-size: var(--digi--typography--label--font-size--desktop);
  line-height: var(--digi--typography--label--line-height--desktop);
  color: var(--digi--color--text--primary);
  font-weight: var(--digi--typography--body--font-weight--desktop);
  cursor: pointer;

  .digi-form-checkbox--layout-block & {
    display: flex;
    padding: var(--digi--form-checkbox--padding--block)
      var(--digi--form-checkbox--padding--inline);
    border-radius: var(--digi--border-radius--primary);

    &:hover {
      background-color: var(
        --digi--form-checkbox--label--background-color--hover
      );
    }
  }
}

.digi-form-checkbox__box {
  cursor: pointer;
  display: flex;
  flex-shrink: 0;
  align-self: flex-start;
  align-items: center;
  justify-content: center;
  background-color: var(--BACKGROUND--DEFAULT);
  border-color: var(--BORDER-COLOR--DEFAULT);
  border-width: var(--digi--form-checkbox--border-width);
  border-style: solid;
  height: var(--digi--form-checkbox--size);
  width: var(--digi--form-checkbox--size);
  border-radius: var(--digi--form-checkbox--border-radius);
  position: relative;
  margin-block-start: calc(
    (
        var(--digi--typography--label--font-size--desktop) *
          var(--digi--typography--label--line-height--desktop) - var(
            --digi--form-checkbox--size
          )
      ) / 2
  );

  &::after {
    @include form__checkbox-check($indeterminate: false);
    opacity: 0;
  }
}

.digi-form-checkbox__input:indeterminate
  ~ .digi-form-checkbox__label
  .digi-form-checkbox__box,
.digi-form-checkbox__input:checked
  ~ .digi-form-checkbox__label
  .digi-form-checkbox__box {
  background-color: var(--BACKGROUND--CHECKED);
  border-color: var(--BORDER-COLOR--CHECKED);
  &::after {
    opacity: 1;
  }
}

.digi-form-checkbox__input:focus-visible ~ .digi-form-checkbox__label {
  .digi-form-checkbox__box {
    @include digi--focus();
  }

  .digi-form-checkbox--layout-block & {
    box-shadow: none;
    outline: var(--digi--focus-outline);
    background-color: var(
      --digi--form-checkbox--label--background-color--hover
    );
  }
}

.digi-form-checkbox__description {
  max-width: var(--digi--paragraph-width--medium);
  line-height: var(--digi--typography--label-description--line-height--desktop);
  font-size: var(--digi--typography--label-description--font-size--desktop);
  padding-inline-start: calc(
    var(--digi--gutter--icon) + var(--digi--form-checkbox--size)
  );

  .digi-form-checkbox--layout-block & {
    padding-inline-start: calc(
      var(--digi--gutter--icon) + var(--digi--form-checkbox--size) +
        var(--digi--form-checkbox--padding--inline)
    );
  }
}
